package com.mjitech.qa.test;

import java.io.IOException;

import org.apache.http.client.ClientProtocolException;
import org.junit.Assert;
import org.testng.annotations.Test;

import com.mjitech.qa.data.LoginDate;
import com.mjitech.qa.data.SetOpenPasswordDate;
import com.mjitech.qa.service.BaseService;
import com.mjitech.qa.data.VaildateLoginNameData;
import net.sf.json.JSONObject;

/**
 * 平板接口逻辑
 * 
 * @author caoyue
 * @date 2018-11-12
 */
public class FlagInterface {
	BaseService service = new BaseService();
	JSONObject json = JSONObject.fromObject("{}");

	/**
	 * 平板登陆接口
	 * @author caoyue
	 * @date 2019-1-9
	 * */
    //@Test(dataProvider = "login", dataProviderClass = LoginDate.class)
	public void login(String loginName,String password) {
		String url = "http://test.mjitech.com/web/wx_work_login_api/login.action" ;
		try {
			json.put("loginName",loginName );
			json.put("password", password);
			json = service.httppostReturnJson(url, service.postParameter(json));
			System.out.println("login result:"+json);
			JSONObject meta = json.getJSONObject("meta");
			if(meta!=null) {
				String code = meta.getString("code");
				Assert.assertEquals("200", code);
			}
		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
    
    /**
	 * 小程序-账号登陆-验证账号是否存在
	 * @author caoyue
	 * @date 2019-1-9
	 * */
    //@Test(dependsOnMethods = "login",dataProvider = "vaildateLoginName", dataProviderClass = VaildateLoginNameData.class)
	public void vaildateLoginName(String storeId,String loginName) {
		String url = "http://test.mjitech.com/web/wx_work_login_api/vaildate_login_name.action" ;
		try {
			json.put("storeId",storeId);
			json.put("loginName", loginName);
			json = service.httppostReturnJson(url, service.postParameter(json));
			System.out.println("vaildate_login_name result:"+json);
//			JSONObject meta = json.getJSONObject("meta");
//			if(meta!=null) {
//				String code = meta.getString("code");
//				Assert.assertEquals("200", code);
//			}
		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
    
	/**
	 * 我要开门-首次开门设置密码
	 * */
	//@Test(dependsOnMethods = "vaildateLoginName" ,dataProvider = "set_open_password", dataProviderClass = SetOpenPasswordDate.class)
	public void setOpenPassword(String storeId,String password) {
		String url = "http://test.mjitech.com/web/wx_work_api/set_open_password.action" ;
		try {
			json.put("storeId",storeId);
			json.put("password", password);
			json = service.httppostReturnJson(url, service.postParameter(json));
			System.out.println("set_open_password result:"+json);
//			JSONObject meta = json.getJSONObject("meta");
//			if(meta!=null) {
//				String code = meta.getString("code");
//				Assert.assertEquals("200", code);
//			}
		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	/**
	 * 统一获取门店信息
	 * 
	 * @param storeId
	 *            门店ID
	 * @author caoyue
	 */
	//@Test
	public void getMachineData() {
		String url = "http://test.mjitech.com/web/pad_warehouse/getMachineData.action";
		String body = "{\"storeId\":\"13\"}";
		try {
			JSONObject result = service.httpPostFlat(url, body);
			String code = result.getJSONObject("meta").getString("code");
			String name = result.getJSONObject("data").getJSONObject("warehouse").getString("name");
			Assert.assertEquals("200", code);
			Assert.assertEquals("华贸商业街", name);
			System.out.println("获取订单信息：" + result);
		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	/**
	 * 获取有权限的任务类型接口
	 * 
	 * @param employeeId
	 * @param storeId
	 *            门店ID
	 * @author caoyue
	 * @date 2018-11-12
	 */
	//@Test
	public void getAlowedTaskAction() {
		String url = "http://test.mjitech.com/web/machine_pad/get_alowed_task.action";
		String body = "{\"employeeId\":\"1\",\"storeId\":\"13\"}";
		try {
			JSONObject result = service.httpPostFlat(url, body);
			String code = result.getJSONObject("meta").getString("code");
			Assert.assertEquals("200", code);
			System.out.println("获取有权限的任务类型接口：" + result);
		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
}
  